<?php

$type = array
(
	1 => '自动升级',
	2 => '手动升级',
);

$score = array
(
	1 => '不清空',
	2 => '清空',
);

return array
(
	# 表名
	'name' => 'level_type',
	# 显示给用户看的名称
	'lang' => '等级类别',
	# 后台菜单排序
	'order' => 1,
	'menu' => false,
	# 数据结构
	'struct' => array
	(
		'id' 		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> 'ID',
			'default' 	=> '',
			'desc' 		=> '',
			'match' 	=> 'is_numeric',
			'search'	=> 'order',
			'list'		=> true,
			'order'		=> 'desc',
		),
		
		'name'		=> array
		(
			'type' 		=> 'varchar-32',
			'name' 		=> '类别名称',
			'default' 	=> '',
			'desc' 		=> '类别名称',
			'match' 	=> 'is_string',
			'update'	=> 'text',
			'search'	=> 'fulltext',
			'list'		=> true,
		),

		'type'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '升级方式',
			'default' 	=> '1',
			'desc' 		=> '升级方式',
			'match' 	=> 'is_numeric',
			'update'	=> 'select',
			'option'	=> $type,
			'search'	=> 'select',
			'list'		=> true,
			'edit'		=> true,
		),

		'score'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '是否清空积分-选择清空将清空等级里设置的积分',
			'default' 	=> '1',
			'desc' 		=> '是否清空积分',
			'match' 	=> 'is_numeric',
			'update'	=> 'select',
			'option'	=> $score,
			'search'	=> 'select',
			'list'		=> true,
			'edit'		=> true,
		),

		'reorder'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '排序-数值越大越靠前，排在前面的类别将优先显示，如设置了VIP等级和普通用户等级，VIP等级的排序比普通用户等级大，VIP等级将优先显示',
			'default' 	=> '1',
			'desc' 		=> '请输入排序',
			'match' 	=> 'option',
			'update'	=> 'text',
			'search'	=> 'order',
			'list'		=> true,
			'order'		=> 'desc',
			'edit'		=> true,
		),

		'state'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '状态',
			'default' 	=> '1',
			'desc' 		=> '请选择状态',
			'match' 	=> 'is_numeric',
		),
		
		'cdate'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '录入时间',
			'match' 	=> array('is_numeric', time()),
			'desc' 		=> '',
			# 只有insert时才生效
			'insert'	=> true,
			'list'		=> 'date("Y-m-d H:i:s", {cdate})',
		),
	),

	# 默认值
	'default' => array
	(
		'col' => 'name,state,cdate',
		'value' => array
		(
			'"默认类别",1,' . time(),
		),
	),

	'manage' => array
	(
		'insert' => false,
		'edit' => false,

		# 自定义快捷新增和编辑
		'button' => array
		(
			'新增' => array('fast'),
		),
		# 快捷更新
		'list_button' => array
		(
			'edit' => array('编辑'),
		),
	),
);
